OpenVDB 5.1.0

Public Types | Public Member Functions | Protected Attributes | Friends | List of all members
DenseStencil< GridT, IsSafe > Class Template Reference

Dense stencil of a given width. More...

`#include <Stencils.h>`

Inherits BaseStencil< DenseStencil< GridT, IsSafe >, GridT, IsSafe >.

## Public Types
typedef GridT | GridType
typedef GridT::TreeType | TreeType
typedef GridType::ValueType | ValueType
typedef tree::ValueAccessor< const TreeType, IsSafe > | AccessorType
typedef std::vector< ValueType > | BufferType
typedef BufferType::iterator | IterType

## Public Member Functions
| DenseStencil (const GridType &grid, int halfWidth)
const ValueType & | getCenterValue () const
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
template<typename IterType >
void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known. More...
void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos. More...
const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil. More...
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil. More...
int | size ()
| Return the size of the stencil buffer. More...
ValueType | median () const
| Return the median value of the current stencil. More...
ValueType | mean () const
| Return the mean value of the current stencil. More...
ValueType | min () const
| Return the smallest value in the stencil buffer. More...
ValueType | max () const
| Return the largest value in the stencil buffer. More...
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil. More...
bool | intersects (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue. More...
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed. More...
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil. More...

## Protected Attributes
const GridType * | mGrid
Coord | mCenter

## Friends
template<typename , typename , bool >
class | BaseStencil

## Detailed Description

### template<typename GridT, bool IsSafe = true>
class openvdb::v5_1::math::DenseStencil< GridT, IsSafe >

Dense stencil of a given width.

## Member Typedef Documentation

## ◆ AccessorType

typedef tree::ValueAccessor<const TreeType, IsSafe> AccessorType
| inherited

## ◆ BufferType

typedef std::vector<ValueType> BufferType
| inherited

## ◆ GridType

typedef GridT GridType

## ◆ IterType

typedef BufferType::iterator IterType
| inherited

## ◆ TreeType

typedef GridT::TreeType TreeType

## ◆ ValueType

typedef GridType::ValueType ValueType

## Constructor & Destructor Documentation

## ◆ DenseStencil()

DenseStencil | ( | const GridType & | grid,
|  | int | halfWidth
| ) |  |
| inline

## Member Function Documentation

## ◆ accessor()

const AccessorType& accessor | ( |  | ) | const
| inline inherited

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ getCenterCoord()

const Coord& getCenterCoord | ( |  | ) | const
| inline inherited

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

const ValueType& getCenterValue | ( |  | ) | const
| inline

## ◆ getValue() [1/2]

const ValueType& getValue | ( | unsigned int | pos = `0` | ) | const
| inline inherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ getValue() [2/2]

const ValueType& getValue | ( |  | ) | const
| inline inherited

Return the value at the specified location relative to the center of the stencil.

## ◆ grid()

const GridType& grid | ( |  | ) | const
| inline inherited

Return a const reference to the grid from which this stencil was constructed.

## ◆ intersects()

bool intersects | ( | const ValueType & | isoValue = `zeroVal<ValueType>()` | ) | const
| inline inherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ max()

ValueType max | ( |  | ) | const
| inline inherited

Return the largest value in the stencil buffer.

## ◆ mean()

ValueType mean | ( |  | ) | const
| inline inherited

Return the mean value of the current stencil.

## ◆ median()

ValueType median | ( |  | ) | const
| inline inherited

Return the median value of the current stencil.

## ◆ min()

ValueType min | ( |  | ) | const
| inline inherited

Return the smallest value in the stencil buffer.

## ◆ moveTo() [1/4]

void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue
| ) |  |
| inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stnecil center
  centerValue | Value of the center element of the stencil

## ◆ moveTo() [2/4]

void moveTo | ( | const Vec3< RealType > & | xyz | ) |
| inline inherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## ◆ moveTo() [3/4]

void moveTo | ( | const Coord & | ijk | ) |
| inline

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

## ◆ moveTo() [4/4]

void moveTo | ( | const IterType & | iter | ) |
| inline

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

## ◆ setValue()

void setValue | ( | const ValueType & | value | ) |
| inline inherited

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

int size | ( |  | ) |
| inline inherited

Return the size of the stencil buffer.

## Friends And Related Function Documentation

## ◆ BaseStencil

friend class BaseStencil
| friend

## Member Data Documentation

## ◆ mCenter

Coord mCenter
| protected inherited

## ◆ mGrid

const GridType* mGrid
| protected inherited

The documentation for this class was generated from the following file:

- Stencils.h